Subject: Re: [RFC net-next 0/5] devlink: Add unique identifier to devlink port function

From: Jakub Kicinski <[email-masked]>
Date: Tue, 6 May 2025 08:20:32 -0700

On Tue, 6 May 2025 14:25:10 +0300 Mark Bloch wrote:
> > Thanks for explaining the setup. Could you please explain the user
> > scenario now? Perhaps thinking of it as a sequence diagram would
> > be helpful, but whatever is easiest, just make it concrete.
> >   
> 
> It's a rough flow, but I believe it clearly illustrates the use case
> we're targeting:
>  
> Some system configuration info:
>  
> - A static mapping file exists that defines the relationship between
>   a host and the corresponding ARM/DPU host that manages it.
>  
> - OVN, OVS and Kubernetes are used to manage network connectivity and
>   resource allocation.
>  
> Flow:
> 1. A user requests a container with networking connectivity.
> 2. Kubernetes allocates a VF on host X. An agent on the host handles VF
>    configuration and sends the PF number and VF index to the central
>    management software.

What is "central management software" here? Deployment specific or
some part of k8s?

> 3. An agent on the DPU side detects the changes made on host X. Using
>    the PF number and VF index, it identifies the corresponding
>    representor, attaches it to an OVS bridge, and allows OVN to program
>    the relevant steering rules.

What does it mean that DPU "detects it", what's the source and 
mechanism of the notification?
Is it communicating with the central SW during  the process? 

> This setup works well when the mapping file defines a one-to-one
> relationship between a host and a single ARM/DPU host.
> It's already supported in upstream today [1]
>  
> However, in a slightly more generic scenario like:
>  
> Control Host A: External host X
>                 External host Y
>  
> A single ARM/DPU host manages multiple external hosts. In this case, step
> 2—where only the PF number and VF index are sent is insufficient. During
> step 3, the agent on the DPU reads the data but cannot determine which
> external host created the VF. As a result, it cannot correctly associate
> the representor with the appropriate OVS bridge.
>  
> To resolve this, we plan to modify step 2 to include the VUID along with
> the PF number and VF index. The DPU-side agent will use the VUID to match
> it with the FUID, identify the correct PF representor, and then use
> standard devlink mechanisms to locate the corresponding VF representor.
> 
> 1: https://github.com/ovn-kubernetes/ovn-kubernetes
> You can look at: go-controller/pkg/util/dpu_annotations.go for more info.

A link to the actual file / relevant code would be more helpful :(